$! Use the ApacheBench utility to generate performance information
$ ab = "$HT_EXE:AB.EXE -d ""-S"""
$ say = "WRITE SYS$OUTPUT"
$!
$! 0KB, ONE AT A TIME
$!
$ say ""
$ say "WASD server - zero script output, 1 concurrent, subprocess"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/cgi-bin/cgiplustest?0" 
$!
$ say ""
$ say "WASD server - zero script output, 1 concurrent, CGIplus"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/cgiplus-bin/cgiplustest?0" 
$!
$ say ""
$ say "WASD server - zero script output, 1 concurrent, ISAPI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/isapi/cgiplustest?0" 
$!
$ say ""
$ say "WASD server - zero script output, 1 concurrent, DECnet CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/decnet/cgiplustest?0" 
$!
$ say ""
$ say "WASD server - zero script output, 1 concurrent, OSU-emulation"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/htbin/cgiplustestosu?0" 
$!
$ say ""
$ say "OSU server - zero script output, 1 concurrent, OSU"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7777/htbin/cgiplustest?0" 
$!
$ say ""
$ say "Apache (CSWS) server - *almost* zero script output, 1 concurrent, CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$!(Apache complains when a script returns zero content, but not if a file has!)
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:8888/cgi-bin/cgiplustest?1" 
$!
$! 0KB, TEN AT A TIME
$!
$ say ""
$ say "WASD server - zero script output, 10 concurrent, subprocess"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/cgi-bin/cgiplustest?0" 
$!
$ say ""
$ say "WASD server - zero script output, 10 concurrent, CGIplus"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/cgiplus-bin/cgiplustest?0" 
$!
$ say ""
$ say "WASD server - zero script output, 10 concurrent, ISAPI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/isapi/cgiplustest?0" 
$!
$ say ""
$ say "WASD server - zero script output, 10 concurrent, DECnet CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/decnet/cgiplustest?0" 
$!
$ say ""
$ say "WASD server - zero script output, 10 concurrent, OSU-emulation"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/htbin/cgiplustestosu?0" 
$!
$ say ""
$ say "OSU server - zero script output, 10 concurrent, OSU"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7777/htbin/cgiplustest?0" 
$!
$ say ""
$ say "Apache (CSWS) server - *almost* zero script output, 10 concurrent, CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$!(Apache complains when a script returns zero content, but not if a file has!)
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:8888/cgi-bin/cgiplustest?1" 
$!
$!
$! 64KB, ONE AT A TIME
$!
$ say ""
$ say "WASD server - 64kB script output, 1 concurrent, subprocess"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/cgi-bin/cgiplustest?800" 
$!
$ say ""
$ say "WASD server - 64kB script output, 1 concurrent, CGIplus"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/cgiplus-bin/cgiplustest?800" 
$!
$ say ""
$ say "WASD server - 64kB script output, 1 concurrent, ISAPI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/isapi/cgiplustest?800" 
$!
$ say ""
$ say "WASD server - 64kB script output, 1 concurrent, DECnet CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/decnet/cgiplustest?800" 
$!
$ say ""
$ say "WASD server - 64kB script output, 1 concurrent, OSU-emulation"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/htbin/cgiplustestosu?800" 
$!
$ say ""
$ say "OSU server - 64kB script output, 1 concurrent, OSU"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7777/htbin/cgiplustest?800" 
$!
$ say ""
$ say "Apache (CSWS) server - 64kB script output, 1 concurrent, CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:8888/cgi-bin/cgiplustest?800" 
$!
$! 64KB, TEN AT A TIME
$!
$ say ""
$ say "WASD server - 64kB script output, 10 concurrent, subprocess"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/cgi-bin/cgiplustest?800" 
$!
$ say ""
$ say "WASD server - 64kB script output, 10 concurrent, CGIplus"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/cgiplus-bin/cgiplustest?800" 
$!
$ say ""
$ say "WASD server - 64kB script output, 10 concurrent, ISAPI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/isapi/cgiplustest?800" 
$!
$ say ""
$ say "WASD server - 64kB script output, 10 concurrent, DECnet CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/decnet/cgiplustest?800" 
$!
$ say ""
$ say "WASD server - 64kB script output, 10 concurrent, OSU-emulation"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/htbin/cgiplustestosu?800" 
$!
$ say ""
$ say "OSU server - 64kB script output, 10 concurrent, OSU"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7777/htbin/cgiplustest?800" 
$!
$ say ""
$ say "Apache (CSWS) server - 64kB script output, 10 concurrent, CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:8888/cgi-bin/cgiplustest?800" 
$!
$! FACE-2-FACE
$!
$ say ""
$ say "WASD server - FACE2FACE.COM, 1 concurrent, CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7080/cgi-bin/face2face" 
$!
$ say ""
$ say "OSU server - FACE2FACE.COM, 1 concurrent, OSU"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:7777/htbin/face2face" 
$!
$ say ""
$ say "Apache (CSWS) server - FACE2FACE.COM, 1 concurrent, CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 1 "http://gamma.dsto.defence.gov.au:8888/cgi-bin/face2face" 
$!
$ say ""
$ say "WASD server - FACE2FACE.COM, 10 concurrent, CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7080/cgi-bin/face2face" 
$!
$ say ""
$ say "OSU server - FACE2FACE.COM, 10 concurrent, OSU"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:7777/htbin/face2face" 
$!
$ say ""
$ say "Apache (CSWS) server - FACE2FACE.COM, 10 concurrent, CGI"
$ say "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$ ab -n 500 -c 10 "http://gamma.dsto.defence.gov.au:8888/cgi-bin/face2face" 
